#ifndef _REFLEX_H_
#define _REFLEX_H_

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>

#include <pktIO.h>
#include <motionClient.h>
#include <jstkClient.h>
#include <sonarClient.h>
#include <dioClient.h>
#include <sysClient.h>

#ifdef __cplusplus
extern "C"
{
#endif

  struct reflex {
    struct reflexMotion   *motion;
    struct reflexJoystick *joystick;
    struct reflexSonar    *sonar;
    struct reflexDio      *dio;
    struct reflexSystem   *system;
    struct pktPort        *pktPort;
    void                  *pArg;
    
    int (*handler) (struct reflex *reflex, int size, unsigned char *buffer, 
		    unsigned char port, unsigned char id,
		    unsigned char opcode);
    
    int (*read)    (struct reflex *reflex, int count);
    int (*destroy) (struct reflex *reflex);
  };
  
  struct reflex *reflexNew(int fd, void *pArg);
  
#ifdef __cplusplus
}
#endif

#endif
